# RAN! Documentation

## Contributing

When contributing to this repository, please first discuss the change you wish to make via issue,
email, or any other method with the owners of this repository before making a change.

Please note we have a code of conduct, please follow it in all your interactions with the project.

## Pull Request Process

1. Ensure any install or build dependencies are removed before the end of the layer when doing a
   build.
2. Update the README.md with details of changes to the interface, this includes new environment
   variables, exposed ports, useful file locations and container parameters.
3. Increase the version numbers in any examples files and the README.md to the new version that this
   Pull Request would represent. The versioning scheme we use is [SemVer](http://semver.org/).
4. You may merge the Pull Request in once you have the sign-off of two other developers, or if you
   do not have permission to do that, you may request the second reviewer to merge it for you.

## Credits
This project exists thanks to all the contributors. Thank you.
<a href="graphs/contributors"><img src="https://opencollective.com/ran/contributors.svg?width=890" /></a>


### Backers

Thank you to all our backers! [[Become a backer](https://opencollective.com/ran#backer)]

<a href="https://opencollective.com/ran#backers" target="_blank"><img src="https://opencollective.com/ran/backers.svg?width=890"></a>


### Sponsors

Thank you to all our sponsors! (please ask your company to also support this open source project by [becoming a sponsor](https://opencollective.com/ran#sponsor))

<a href="https://opencollective.com/ran/sponsor/0/website" target="_blank"><img src="https://opencollective.com/ran/sponsor/0/avatar.svg"></a>
<a href="https://opencollective.com/ran/sponsor/1/website" target="_blank"><img src="https://opencollective.com/ran/sponsor/1/avatar.svg"></a>
<a href="https://opencollective.com/ran/sponsor/2/website" target="_blank"><img src="https://opencollective.com/ran/sponsor/2/avatar.svg"></a>
<a href="https://opencollective.com/ran/sponsor/3/website" target="_blank"><img src="https://opencollective.com/ran/sponsor/3/avatar.svg"></a>
<a href="https://opencollective.com/ran/sponsor/4/website" target="_blank"><img src="https://opencollective.com/ran/sponsor/4/avatar.svg"></a>
<a href="https://opencollective.com/ran/sponsor/5/website" target="_blank"><img src="https://opencollective.com/ran/sponsor/5/avatar.svg"></a>